#include <allegro.h>
#include <cstdlib>
#include <cmath>
#include <ctime>
using namespace std;

// Lösche Bildschirm
void clear_screen()
{
  rectfill(screen, 0, 0, 659, 479, makecol(0,0,0));
}
// Spielertaste?
int is_player_key(int player)
{
  int keyvalue = 0;
  switch(player)
  {
    case 0:
      if(key[KEY_1])
	keyvalue = 1;
      if(key[KEY_Q])
	keyvalue = 2;
      break;
    case 1:
      if(key[KEY_LCONTROL])
	keyvalue = 1;
      if(key[KEY_ALT])
	keyvalue = 2;
      break;
    case 2:
      if(key[KEY_M])
	keyvalue = 1;
      if(key[KEY_COMMA])
	keyvalue = 2;
      break;
    case 3:
      if(key[KEY_LEFT])
	keyvalue = 1;
      if(key[KEY_DOWN])
	keyvalue = 2;
      break;
    case 5:
      if(mouse_b == 1)
	keyvalue = 1;
      if(mouse_b == 2)
	keyvalue = 2;
      break;
    case 4:
      if(key[KEY_SLASH_PAD])
	keyvalue = 1;
      if(key[KEY_ASTERISK])
	keyvalue = 2;
      break;
  }
  return keyvalue;
}
// Koordinate
class Koordinate
{
  public:
    // Variablen
    float x;
    float y;
    // Funktionen
    Koordinate()
    {
      // while(true) do_nothing(); // ;-)
    }
    bool same(Koordinate koord2)
    {
      bool retval = false;
      if(koord2.x == x)
      {
	if(koord2.y == y)
	{
	  retval = true;
	}
      }
      return retval;
    }
};
// Definition von Kurve
class Kurve
{
  private:
    // Variablen
    float direction;
    Koordinate cur_pos;
    Koordinate last_pixels[4];
    int color;
    int next_gap_draws;
    int gapsnooze;
  public:
    // Variablen
    
    // Funktionen
    // Constructor
    Kurve()
    {
      next_gap_draws = rand() % 100 + 100;
      gapsnooze = 0;
    }
    void init(int Alleg_color, Koordinate starthere, int startdirection)
    {
      color = Alleg_color;
      direction = startdirection;
      cur_pos.x = starthere.x;
      cur_pos.y = starthere.y;
      // Zeichne ersten pukt mit "crazy" effekt ;-)
      for(int ci = 0; ci <= 6; ++ci)
      {
	rectfill(screen, (int) cur_pos.x, (int) cur_pos.y, (int) cur_pos.x+1, (int) cur_pos.y+1, color);
	rest(60);
	rectfill(screen, (int) cur_pos.x, (int) cur_pos.y, (int) cur_pos.x+1, (int) cur_pos.y+1, makecol(0,0,0));
	rest(60);
      }
      rectfill(screen, (int) cur_pos.x, (int) cur_pos.y, (int) cur_pos.x+1, (int) cur_pos.y+1, color);
      // Position Speichern
      last_pixels[0].x = cur_pos.x; last_pixels[0].y = cur_pos.y;
      last_pixels[1].x = cur_pos.x+1; last_pixels[1].y = cur_pos.y;
      last_pixels[2].x = cur_pos.x+1; last_pixels[2].y = cur_pos.y+1;
      last_pixels[3].x = cur_pos.x; last_pixels[3].y = cur_pos.y+1;
    }
    void mod_direction(float degree_diff)
    {
      direction += degree_diff;
      if(direction >= 360)
      {
	direction -= 360;
      }
      if(direction < 0)
      {
	direction *= -1;
      }
    }
    bool draw_next_pixels()
    {
      int gaplength = 0;
      Koordinate next_pixels[4];
      bool retval;
      --next_gap_draws;
      Koordinate nextkoord;
      nextkoord.x = cur_pos.x + ( cos(direction) * ( 1 ) );
      nextkoord.y = cur_pos.y + ( sin(direction) * ( 1 ) );
      if(gapsnooze != 0)
      {
	--gapsnooze;
	cur_pos = nextkoord;
	retval = true;
      }
      else
      {
      if(next_gap_draws == 0)
      { 
	next_gap_draws = rand() % 100 + 100;
	gapsnooze = rand() % 3+7;
      }
      
      // Pixel:
      next_pixels[0].x = (int) nextkoord.x; next_pixels[0].y = (int) nextkoord.y;
      next_pixels[1].x = (int) nextkoord.x+1; next_pixels[1].y = (int) nextkoord.y;
      next_pixels[2].x = (int) nextkoord.x+1; next_pixels[2].y = (int) nextkoord.y+1;
      next_pixels[3].x = (int) nextkoord.x; next_pixels[3].y = (int) nextkoord.y+1;
      int ci;
      int ac;
      // Überschneidungen?
      bool intersect = false;
      bool is_old_one;
      for(ci = 0; ci <= 3; ++ci)
      {
	if(!intersect)
	{
	  if(getpixel(screen, (int) next_pixels[ci].x, (int) next_pixels[ci].y) != makecol(0,0,0))
	  {
	    intersect = true;
	    // Einer der letzten Pixel?
	    is_old_one = false;
	    for(ac = 0; ac <= 3; ++ac)
	    {
	      if(!is_old_one)
	      {
		is_old_one = next_pixels[ci].same(last_pixels[ac]);
	      } else break;
	    }
	    if(is_old_one)
	    {
	      intersect = false;
	    }
	  }
	} else break;
      }
      if(!intersect)
      {
	// Pixel zeichnen und speichern
	// Spiechern
	cur_pos = nextkoord;
	for(ci = 0; ci <= 3; ++ci)
	{
	  last_pixels[ci].x = next_pixels[ci].x; last_pixels[ci].y = next_pixels[ci].y;
	}
	// Zeichnen
	for(ci = 0; ci <= 3; ++ci)
	{
	  putpixel(screen, (int) next_pixels[ci].x, (int) next_pixels[ci].y, color);
	}
	retval = true;
      }
      else
	retval = false;
      }
      return retval; 
    }
    
};

int main()
{
  // Zufall einstellen
  srand((unsigned)time(0));
  // Variablen
  bool should_cont = false;
  bool players_active[6];
  bool players_alive[6];
  bool intersect;
  bool someone_won = false;
  int player_colors[6][3];
  int ci = 0;
  int ac;
  int pl_punkte[6];
  Kurve pl_kurven[6];
  Koordinate temp_koord;
  Koordinate startkoords[6];
  // Initializing...
  allegro_init();
  install_keyboard();
  install_mouse();
  install_timer();
  set_color_depth(16);
 set_gfx_mode( GFX_AUTODETECT, 640, 480, 0, 0);
 /*set_gfx_mode(GFX_AUTODETECT_WINDOWED, 640, 480, 0, 0);
    set_window_title("ZATACKA"); //Titel des Fensters wird benannnt
    show_os_cursor(MOUSE_CURSOR_ARROW); //die Maus wird angezeigt*/
  for(ci = 0; ci <= 5; ++ci)
  {
     players_active[ci] = false;
  }
  // Spielerfarben
  player_colors[0][0] = 255; player_colors[0][1] = 0; player_colors[0][2] = 0;
  player_colors[1][0] = 255; player_colors[1][1] = 255; player_colors[1][2] = 0;
  player_colors[2][0] = 255; player_colors[2][1] = 150; player_colors[2][2] = 0;
  player_colors[3][0] = 0; player_colors[3][1] = 200; player_colors[3][2] = 0;
  player_colors[4][0] = 255; player_colors[4][1] = 0; player_colors[4][2] = 255;
  player_colors[5][0] = 0; player_colors[5][1] = 0; player_colors[5][2] = 255;
  // Schriftart laden
  FONT *coolefont;
  FONT *pixelfont;
  coolefont = load_font("PAL_BI_24.pcx", NULL, NULL);
  pixelfont = load_font("pixeledfon.pcx", NULL, NULL);
  // Hauptschleife
  // sprungmarke
/* -------START------- */
  m_start:;
  for(ci = 0; ci <= 5; ++ci)
    {
      players_active[ci] = false;
    }
    // Startscreen
    clear_screen();
    textprintf_ex(screen, coolefont, 180, 200, makecol(255,255,255), makecol(0,0,0), "Achtung, die Kurve!");
    rest(500);
    textprintf_ex(screen, font, 180,195, makecol(100,100,100),makecol(0,0,0), "Just another");
    textprintf_right_ex(screen, font, 500,240, makecol(100,100,100),makecol(0,0,0), "Clone");
    textprintf_ex(screen, font, 0, 470, makecol(255,255,255), makecol(0,0,0), "(c) by Skadu  skadu-server.mine.nu/~skadu");
    readkey();
    
    clear_screen();
    // Spieler
    textprintf_ex(screen, coolefont, 10, 10, makecol(255,0,0), makecol(0,0,0), "P1      1       Q");
    textprintf_ex(screen, coolefont, 10, 50, makecol(255,255,0), makecol(0,0,0), "P2      Ctrl    Alt");
    textprintf_ex(screen, coolefont, 10, 90, makecol(255,150,0), makecol(0,0,0), "P3      M       ,");
    textprintf_ex(screen, coolefont, 10, 130, makecol(0,200,0), makecol(0,0,0), "P4      Left    Down");
    textprintf_ex(screen, coolefont, 10, 170, makecol(255,0,255), makecol(0,0,0), "P5      /       *");
    textprintf_ex(screen, coolefont, 10, 210, makecol(0,0,255), makecol(0,0,0), "P6      Mouse_L Mouse_R");
    while(true)
    {
      should_cont = false;
      
      // Zustandsänderung?
      for(ci = 0; ci <= 5; ++ci)
      {
	if(is_player_key(ci) == 1)
	  players_active[ci] = true;
	if(is_player_key(ci) == 2)
	  players_active[ci] = false;
      }
      // Zustand darstellen
      for(ci = 0; ci <= 5; ++ci)
      {
	if(players_active[ci])
	  textprintf_ex(screen, pixelfont, 500, 22+(40*ci), makecol(player_colors[ci][0], player_colors[ci][1], player_colors[ci][2]), makecol(0,0,0), "READY");
	else
	  textprintf_ex(screen, pixelfont, 500, 22+(40*ci), makecol(0,0,0), makecol(0,0,0), "READY");
      }
      // Escape Taste?
      if(key[KEY_ESC])
	goto m_end;
      if(key[KEY_SPACE])
      {
	ac = 0;
	for(ci = 0; ci <= 5; ++ci)
	{
	  if(players_active[ci])
	    ++ac;
	}
	if(ac >= 2)
	{
	  goto m_game_init;
	}
      }
    }
    
/* ---Spielinitialisierung---*/
m_game_init:;
clear_screen();
      // Zeichne Spielfeld
      // Zeichne Basisrecteck
      rect(screen, 0, 0, 580, 479, makecol(255,255,255));
      // Zeichne Leiste
      for(ci = 0; ci <= 4; ++ci)
      {
	vline(screen, 581+ci, 0, 479, makecol(200-(25*ci),200-(25*ci),200-(25*ci)));
      }
      rectfill(screen,586,0,639,479,makecol(75,75,75));
      // Punkte auf 0 setzen
      for(ci = 0; ci <= 5; ++ci)
      {
	pl_punkte[ci] = 0;
      }
      goto m_ingame;
      
/* ---Hauptspiel--- */
m_ingame:;
// Init-Game
	// leere das Spielfeld
	rectfill(screen, 1, 1, 579, 478, makecol(0,0,0));
	// Punkte Spawnen
	for(ci = 0; ci <= 5; ++ci)
	{
	  startkoords[ci].x = 0;
	  startkoords[ci].y = 0;
	}
	for(ci = 0; ci <= 5; ++ci)
	{
	  intersect = true;
	  temp_koord.x = 0;
	  temp_koord.y = 0;
	  while(intersect)
	  {
	    intersect = false;
	    // Überschneidungen?
	    if(temp_koord.x == 0 && temp_koord.y == 0)
	    {
	      intersect = true;
	    }
	    else
	    {
	      for(ac = 0; ac <= 5; ++ac)
	      {
		intersect = temp_koord.same(startkoords[ac]);
	      }
	    }
	    if(intersect)
	    {
	      // Zufall
	      temp_koord.x = rand() % (478/2) + 1;
	      temp_koord.y = rand() % (578/2) + 1;
	    }
	  }
	  // Setze Koordinate
	  startkoords[ci] = temp_koord;
	}
	// Init der Kurevn
	for(ci = 0; ci <= 5; ++ci)
	{
	  if(players_active[ci])
	  {
	    pl_kurven[ci].init(makecol(player_colors[ci][0],player_colors[ci][1],player_colors[ci][2]), startkoords[ci], rand() % 359 + 1);
	  }
	}
	// Das eigentliche Spiel:
	// Alle sind noch "am leben"
	for(ci = 0; ci <= 5; ++ci)
	{
	  players_alive[ci] = players_active[ci];
	}
	while(true)
	{
	  // Kontrolle
	  for(ci = 0; ci <= 5; ++ci)
	  {
	    if(players_alive[ci])
	    {
	      if(is_player_key(ci) == 1)
		pl_kurven[ci].mod_direction(-0.04);
	      if(is_player_key(ci) == 2)
		pl_kurven[ci].mod_direction(0.04);
	    }
	  }
	  // Zeichnen, Kollisionskontrolle, etc.
	  for(ci = 0; ci <= 5; ++ci)
	  {
	    if(players_alive[ci])
	    {
	      intersect = !pl_kurven[ci].draw_next_pixels();
	      if(intersect)
	      {
		// Vergebe Punkte und setze alive-status
		players_alive[ci] = false;
		for(ac = 0; ac <= 5; ++ac)
		{
		  if(players_alive[ac])
		  {
		    ++pl_punkte[ac];
		  }
		}
	      }
	    }
	  }
	  // Punktzahl darstellen
	  for(ci = 0; ci <= 5; ++ci)
	  {
	    if(players_active[ci])
	    {
	      textprintf_ex(screen, coolefont, 590, 35 * (ci +1), makecol(player_colors[ci][0], player_colors[ci][1], player_colors[ci][2]), makecol(75,75,75), "%d", pl_punkte[ci]);
	    }
	  }
	  // wurde die Runde gewonnewn?
	  ac = 0;
	  for(ci = 0; ci <= 5; ++ci)
	  {
	    if(players_alive[ci])
	      ++ac;
	  }
	  if(ac <= 1)
	    break;
	  // Schlafe kurz
	  rest(25);
	}
while(!key[KEY_SPACE] && !key[KEY_ESC])
	{}
	should_cont = true;
	if(key[KEY_ESC])
	{
	  // Zurück zum start
	  rest(100);
	  goto m_start;
	}
	if(key[KEY_SPACE])
	{
	  // Hat jemand gewonnen?
	  ac = 0;
	  for(ci = 0; ci <= 5; ++ci)
	  {
	    if(players_active[ci])
	    {
	      ++ac;
	    }
	  }
	  someone_won =false;
	  for(ci = 0; ci <= 5; ++ci)
	  {
	    if(players_active[ci])
	    {
	      if(!someone_won)
	      if(pl_punkte[ci] >= ((ac-1) * 10))
		someone_won = true;
	    }
	  }
	  if(someone_won)
	  {
	    clear_screen();
	    // Es hat jemand gewonnen!
	    for(ci = 0; ci <= 5; ++ci)
	    {
	      if(players_active[ci])
	      {
		textprintf_ex(screen, pixelfont, 200, 26 * (ci +1), makecol(player_colors[ci][0], player_colors[ci][1], player_colors[ci][2]), makecol(0,0,0), "%d", pl_punkte[ci]);
	      }
	    }
 	    // Konec hry
	    textprintf_centre_ex(screen, coolefont, 320, 430, makecol(255,255,255), makecol(0,0,0), "Konec hry");
	    // Auf Space/Escape warten...
	    rest(100);
	    while(!key[KEY_SPACE] && !key[KEY_ESC])
	    {}
	    should_cont = true;
	    if(key[KEY_ESC])
	      goto m_end;
	    else
	      goto m_start;
	  }
	}
	goto m_ingame;



/* ---END--- */
m_end:;
destroy_font(coolefont);
destroy_font(pixelfont);
allegro_exit();
}
END_OF_MAIN();
